﻿using System.Collections.Generic;
using System.Configuration;
using MySql.Data.MySqlClient;
using TreeViewDetailed.Model;

namespace TreeViewDetailed.ViewModel
{
  public class TreeViewDetailedViewModel
  {
    private string JoomlaConStr = ConfigurationManager.ConnectionStrings["JoomlaCon"].ConnectionString;
    public List<CategoriesListModel> CategoriesList { get; set; }
    public TreeViewDetailedViewModel()
    {
      var connection = new MySqlConnection(JoomlaConStr);

      string sql = "select * from jos_categories where level = 0 order by id ";

      var cmdSel = new MySqlCommand(sql, connection);

      connection.Open();

      MySqlDataReader dataReader = cmdSel.ExecuteReader();

      CategoriesList = new List<CategoriesListModel>();
      var i = 0;
      while (dataReader.Read())
      {
        i++;

        CategoriesList.Add(new CategoriesListModel
        {
          Name = dataReader["title"].ToString(),
          Id = int.Parse(dataReader["id"].ToString()),
          Categories = new List<CategoriesListModel>()
        });
      }

      CreateListRecursively(CategoriesList);

    }

    private void CreateListRecursively(List<CategoriesListModel> CategoriesList)
    {
      int i = -1;
      foreach (CategoriesListModel category in CategoriesList)
      {
        i++;

        var connection = new MySqlConnection(JoomlaConStr);

        string sql = "select * from jos_categories where parent_id = " + category.Id + " order by id ";

        var cmdSel = new MySqlCommand(sql, connection);

        connection.Open();

        MySqlDataReader dataReader = cmdSel.ExecuteReader();

        while (dataReader.Read())
        {
          CategoriesList[i].Categories.Add(new CategoriesListModel
          {
            Name = dataReader["title"].ToString(),
            Id = int.Parse(dataReader["id"].ToString()),
            Categories = new List<CategoriesListModel>()
          });
        }

        CreateListRecursively(CategoriesList[i].Categories);
      }
    }

  }
}